module reg_file(clock,reset,ds,dt,dd,rs,rt,rd,write_enable);
parameter BITS = 32;
input [BITS-1:0] dd;
output [BITS-1:0] ds,dt;
input [4:0] rs,rt,rd;
input clock, write_enable, reset;
reg [BITS-1:0] r[1:31];
integer i;

always @(posedge clock or negedge reset)
begin
	if (!reset)
		for (i=1; i<32; i=i+1) r[i] = i;
	else if (write_enable && rd) r[rd] = dd;
end

assign ds = (rs? r[rs]: 0);
assign dt = (rt? r[rt]: 0);

endmodule			